version: "3.8"

services:
  traefik:
    image: ${TRAEFIK_IMAGE}
    container_name: traefik
    restart: unless-stopped
    depends_on:
      - docker-proxy
    networks:
      - web
      - docker-proxy
    ports:
      - "80:80"
      - "443:443"
    volumes:
      - "./letsencrypt:/letsencrypt"
      - "./traefik/traefik-dynamic-config.toml:/traefik-dynamic-config.toml"
    command:
      - "--api=false"
      - "--global.sendAnonymousUsage=false"
      - "--log.level=${TRAEFIK_LOG_LEVEL:-ERROR}"
      - "--providers.file.filename=/traefik-dynamic-config.toml"
      - "--providers.docker=true"
      - "--providers.docker.exposedByDefault=false"
      - "--providers.docker.endpoint=tcp://docker-proxy:2375"
      - "--providers.docker.network=web"
      - "--entrypoints.web.address=:80"
      - "--entrypoints.web.http.redirections.entryPoint.to=websecure"
      - "--entrypoints.web.http.redirections.entrypoint.scheme=https"
      - "--entrypoints.web.http.redirections.entrypoint.permanent=true"
      - "--entrypoints.websecure.address=:443"
      - "--certificatesresolvers.route53.acme.dnschallenge=true"
      - "--certificatesresolvers.route53.acme.dnschallenge.provider=route53"
      - "--certificatesresolvers.route53.acme.storage=/letsencrypt/route53.json"
    env_file:
      - .env

  docker-proxy:
    image: ${DOCKER_PROXY_IMAGE}
    container_name: docker-proxy
    restart: unless-stopped
    networks:
      - docker-proxy
    volumes:
      - "/var/run/docker.sock:/var/run/docker.sock:ro,delegated"
    environment:
      CONTAINERS: 1

  oaipmh:
    image: ${OAIPMH_IMAGE}
    container_name: oaipmh
    restart: unless-stopped
    env_file:
      - .env
    depends_on:
      - traefik
    networks:
      - web
    ports:
      - "8085:8085"
    labels:
      - "traefik.enable=true"
      - "traefik.docker.network=web"
      - "traefik.http.routers.oaipmh.rule=${FQDN:?err}"
      - "traefik.http.routers.oaipmh.entrypoints=websecure"
      - "traefik.http.routers.oaipmh.tls.certresolver=route53"
networks:
  web:
    name: web
    internal: false
  docker-proxy:
    name: docker-proxy
    internal: true
